/*
 * File:	DemoIMX_ADC.cpp
 *
 * Date:	2013-03-19
 * Company:	DH electronics GmbH
 * Author:	Ludwig Zenz, lzenz@dh-electronics.de
 *
 * Remark:	The following code aims to offer you some help
 * 			with the IMX25_ADC operations in Linux user-space programs.
 */



/* Header */
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <asm/types.h>

#include "imx_adc.h"

int main(void)
{
  struct t_adc_convert_param convert_param;

  int fd = open("/dev/imx_adc", O_RDONLY);

  ioctl(fd, IMX_ADC_INIT, NULL);

  /* Read Channel ADC0 */
  convert_param.channel = GER_PURPOSE_ADC0;
  convert_param.result[0] = 0;
  ioctl(fd, IMX_ADC_CONVERT, &convert_param);
  printf("Converted value: %hu\n", convert_param.result[0]);

  /* Read Channel ADC1 */
  convert_param.channel = GER_PURPOSE_ADC1;
  convert_param.result[0] = 0;
  ioctl(fd, IMX_ADC_CONVERT, &convert_param);
  printf("Converted value: %hu\n", convert_param.result[0]);

  /* Read Channel ADC2 */
  convert_param.channel = GER_PURPOSE_ADC2;
  convert_param.result[0] = 0;
  ioctl(fd, IMX_ADC_CONVERT, &convert_param);
  printf("Converted value: %hu\n", convert_param.result[0]);

  /* This does read 4 values for each general purpose ADC */
  convert_param.channel = GER_PURPOSE_MULTICHNNEL;
  ioctl(fd, IMX_ADC_CONVERT_MULTICHANNEL, &convert_param);

  for (int index = 0; index < 12; index++)
  {
	  printf("Converted value CH%i value %i: %hu\n", index/4, index%4, convert_param.result[index]);
  }

  ioctl(fd, IMX_ADC_DEINIT, NULL);

  close(fd);

  return 0;

}
